## kte-collaborative 0.2.0

=== CMakeLists.txt ===
#
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING-CMAKE-SCRIPTS file.

project(kobby)
cmake_minimum_required(VERSION 2.6)
set( CMAKE_MODULE_PATH ${CMAKE_MODULE_PATH} ${CMAKE_SOURCE_DIR}/CMakeModules )

set(KTECOLLAB_VERSION_MAJOR 0)
set(KTECOLLAB_VERSION_MINOR 1)
set(KTECOLLAB_VERSION_PATCH 80)
set(KTECOLLAB_VERSION_STRING ${KTECOLLAB_VERSION_MAJOR}.${KTECOLLAB_VERSION_MINOR}.${KTECOLLAB_VERSION_PATCH})
set(LIBINFINITY_VERSION 0.5) # TODO use this for finding libinfinity

configure_file(version.h.in version.h)

find_package(KDE4 REQUIRED)
find_package(Libqinfinity REQUIRED)

# TODO: make optional?
set(IS_KTP_INTERNAL_MODULE TRUE) # aw yeah
find_package(TelepathyQt4 0.8.9 REQUIRED)
find_package(KTp REQUIRED)

include(KDE4Defaults)

add_definitions("-DENABLE_TAB_HACK")

add_subdirectory(kte-plugin)
add_subdirectory(kioslave)
add_subdirectory(common)
add_subdirectory(tests)
add_subdirectory(notifier-module)
include(MacroOptionalAddSubdirectory)
macro_optional_add_subdirectory( po )

=== common/CMakeLists.txt ===
# Copyright (c) 2013 Sven Brauch <svenbrauch@gmail.com>
# The common directory (and library) contais functionality which is common to both the KTE plugin and the kioslave.
# Since both need the whole connection and browser stuff, this is a quite large part of the code base.

# Check if KTE is new enough to have the BufferInterface
try_compile( HAVE_BUFFERIFACE ${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/testbufferinterface.cpp
             CMAKE_FLAGS "-DINCLUDE_DIRECTORIES=${KDE4_INCLUDES}"
             LINK_LIBRARIES ${KDE4_KTEXTEDITOR_LIBS} )
if(HAVE_BUFFERIFACE)
    add_definitions("-DKTEXTEDITOR_HAS_BUFFER_IFACE")
endif(HAVE_BUFFERIFACE)

include_directories(
    ${KDE4_INCLUDES}
    ${LIBQINFINITY_INCLUDES}
    ${CMAKE_BINARY_DIR}/ktecollaborative
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/common/
)

set( KTECOLLABORATIVE_COMMON_SRCS
    connection.cpp
    document.cpp
    itemfactory.cpp
    noteplugin.cpp
    utils.cpp
    selecteditorwidget.cpp
)

kde4_add_library(ktecollaborativecommon SHARED ${KTECOLLABORATIVE_COMMON_SRCS})
set_target_properties( ktecollaborativecommon
    PROPERTIES
    VERSION ${KTECOLLAB_VERSION_STRING}
    SOVERSION ${KTECOLLAB_VERSION_STRING}
)
target_link_libraries( ktecollaborativecommon
    ${KDE4_KDEUI_LIBS}
    ${KDE4_KFILE_LIBS}
    ${KDE4_KTEXTEDITOR_LIBS}
    ${KDE4_KDECORE_LIBS}
    ${KDE4_KDNSSD_LIBS}
    ${LIBQINFINITY_LIBRARIES}
)

install(TARGETS ktecollaborativecommon DESTINATION ${INSTALL_TARGETS_DEFAULT_ARGS})

=== kioslave/CMakeLists.txt ===
include_directories(
    ${KDE4_INCLUDES}
    ${LIBQINFINITY_INCLUDES}
    ${CMAKE_BINARY_DIR}/kobby
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_SOURCE_DIR}/kobby/
    ${CMAKE_SOURCE_DIR}/kobby/editor/
    ${CMAKE_SOURCE_DIR}/kobby/dialogs/
)

set(kio_infinity_PART_SRCS
    kio_infinity.cpp
)
kde4_add_plugin(kio_infinity ${kio_infinity_PART_SRCS})

target_link_libraries(kio_infinity
    ktecollaborativecommon
    ${KDE4_KIO_LIBS}
    ${LIBQINFINITY_LIBRARIES}
    ${KDE4_KTEXTEDITOR_LIBS}
    ${KDE4_KDNSSD_LIBS}
)

install( TARGETS kio_infinity DESTINATION ${PLUGIN_INSTALL_DIR} )
install( FILES infinity.protocol DESTINATION  ${SERVICES_INSTALL_DIR} )

=== kte-plugin/CMakeLists.txt ===
# Copyright (c) 2008 Gregory Haynes <greg@greghaynes.net>
# Copyright (c) 2013 Sven Brauch <svenbrauch@gmail.com>
#
# Redistribution and use is allowed according to the terms of the BSD license.
# For details see the accompanying COPYING-CMAKE-SCRIPTS file.
#

cmake_minimum_required(VERSION 2.8)

add_subdirectory(settings)
add_subdirectory(ktpintegration)

find_package(KDE4 4.5.0 REQUIRED)
include(KDE4Defaults)

set( ktecollaborative_PART_SRCS
    documentchangetracker.cpp
    ktecollaborativepluginview.cpp
    ktecollaborativeplugin.cpp
    manageddocument.cpp
    ui/remotechangenotifier.cpp
    ui/sharedocumentdialog.cpp
    ui/opencollabdocumentdialog.cpp
    ui/statusoverlay.cpp
    settings/kcm_kte_collaborative.cpp
)

add_definitions(-fPIC)
automoc4(ktecollaborative_objects ktecollaborative_PART_SRCS)
add_library(ktecollaborative_objects OBJECT ${ktecollaborative_PART_SRCS})

set(CMAKE_INSTALL_RPATH ${LIB_INSTALL_DIR}/ktecollaborative/)
kde4_add_plugin(ktexteditor_collaborative $<TARGET_OBJECTS:ktecollaborative_objects>)

include_directories(
    ${TELEPATHY_QT4_INCLUDE_DIR}
    ${KTP_INCLUDE_DIR}
    ${KDE4_INCLUDES}
    ${LIBQINFINITY_INCLUDES}
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_BINARY_DIR}
)

target_link_libraries( ktexteditor_collaborative
    ktecollaborativecommon
    inftube
    ${KDE4_KCMUTILS_LIBS}
    ${KDE4_KDEUI_LIBS}
    ${KDE4_KIO_LIBS}
    ${KDE4_KFILE_LIBS}
    ${KDE4_KTEXTEDITOR_LIBS}
    ${KDE4_KDECORE_LIBS}
    ${KDE4_KDNSSD_LIBS}
    ${LIBQINFINITY_LIBRARIES}
    ${QT_QTDECLARATIVE_LIBRARIES}
    ${KDE4_KDEUI_LIBS}
    ${TELEPATHY_QT4_LIBRARIES}
    ${KTP_LIBRARIES}
    ${KDE4_KIO_LIBS}
    ${KTP_MODELS_LIBRARIES}
    ${KTP_WIDGETS_LIBRARIES}
)

install(TARGETS ktexteditor_collaborative DESTINATION ${PLUGIN_INSTALL_DIR} )
install(FILES ktexteditor_collaborative.desktop settings/ktexteditor_collaborative_config.desktop DESTINATION  ${SERVICES_INSTALL_DIR})
install(FILES ktexteditor_collaborativeui.rc  DESTINATION  ${DATA_INSTALL_DIR}/ktecollaborative/)
install(FILES ui/notifywidget.qml ui/overlay.qml DESTINATION ${DATA_INSTALL_DIR}/ktecollaborative/ui)

=== notifier-module/CMakeLists.txt ===

include_directories(
    ${KDE4_KIO_INCLUDES}
    ${KDE4_INCLUDES}
    ${LIBQINFINITY_INCLUDES}
    ${CMAKE_SOURCE_DIR}
    ${CMAKE_BINARY_DIR}
)

set(infinotenotifier_SRCS
   infinotenotifier.cpp
)

kde4_add_executable(infinotenotifier ${infinotenotifier_SRCS})

target_link_libraries(infinotenotifier
                      ktecollaborativecommon
                      ${KDE4_KIO_LIBS}
                      ${LIBQINFINITY_LIBRARIES}
)

# TODO can't we do this without an absolute path? It sucks.
configure_file( infinotenotifier.desktop.in infinotenotifier.desktop )
install( TARGETS infinotenotifier DESTINATION ${LIBEXEC_INSTALL_DIR} )
install( FILES ${CMAKE_CURRENT_BINARY_DIR}/infinotenotifier.desktop DESTINATION ${SERVICES_INSTALL_DIR} )
install( FILES infinotenotifier.notifyrc DESTINATION ${DATA_INSTALL_DIR}/infinotenotifier )

=== po/CMakeLists.txt ===
# The pofiles macro creates in some versions same name targets
# which since cmake 2.8 leads to target clashes.
# Hence force the old policy for all po directories.
# http://public.kitware.com/Bug/view.php?id=12952
cmake_policy(SET CMP0002 OLD)

find_package(Gettext REQUIRED)
if (NOT GETTEXT_MSGMERGE_EXECUTABLE)
MESSAGE(FATAL_ERROR "Please install msgmerge binary")
endif (NOT GETTEXT_MSGMERGE_EXECUTABLE)
if (NOT GETTEXT_MSGFMT_EXECUTABLE)
MESSAGE(FATAL_ERROR "Please install msgmerge binary")
endif (NOT GETTEXT_MSGFMT_EXECUTABLE)
add_subdirectory(bs)
add_subdirectory(pt_BR)
add_subdirectory(pl)
add_subdirectory(fr)
add_subdirectory(uk)
add_subdirectory(nl)
add_subdirectory(de)
add_subdirectory(ug)
add_subdirectory(hu)
add_subdirectory(cs)
add_subdirectory(sk)
add_subdirectory(sv)
add_subdirectory(pt)

=== tests/CMakeLists.txt ===
automoc4(collaborativeeditingtest collaborativeeditingtest.cpp)
kde4_add_unit_test(
    collaborativeeditingtest
    collaborativeeditingtest.cpp
    $<TARGET_OBJECTS:ktecollaborative_objects>
)

include_directories(
    ${KDE4_INCLUDES}
    ../common
    ../kte-plugin
    ../
    ${LIBQINFINITY_INCLUDES}
)

target_link_libraries( collaborativeeditingtest
    ${KDE4_KFILE_LIBS}
    ${KDE4_KTEXTEDITOR_LIBS}
    ${KDE4_KCMUTILS_LIBS}
    ${KDE4_KDECORE_LIBS}
    ${KDE4_KDNSSD_LIBS}
    ${LIBQINFINITY_LIBRARIES}
    ${QT_QTDECLARATIVE_LIBRARIES}
    ${QT_QTTEST_LIBRARY}
    ${TELEPATHY_QT4_LIBRARIES}
    ${KTP_LIBRARIES}
    ${KDE4_KIO_LIBS}
    ${KTP_MODELS_LIBRARIES}
    ${KTP_WIDGETS_LIBRARIES}
    ktecollaborativecommon
    inftube
)

=== kte-plugin/ktpintegration/CMakeLists.txt ===
set(inftube_SRCS
    connectionswidget.cpp
    inftube.cpp
)

set(IS_KTP_INTERNAL_MODULE TRUE) # aw yeah
find_package(TelepathyQt4 0.8.9 REQUIRED)
find_package(KTp 0.6.80 REQUIRED)
include_directories(
    ${QT_INCLUDES}
    ${KDE4_INCLUDES}
    ${TELEPATHY_QT4_INCLUDE_DIR}
    ${KTP_INCLUDE_DIR}
    ${CMAKE_SOURCE_DIR}
    ${LIBQINFINITY_INCLUDES}
)

kde4_add_library(inftube SHARED ${inftube_SRCS})
set_target_properties( inftube
    PROPERTIES
    VERSION ${KTECOLLAB_VERSION_STRING}
    SOVERSION ${KTECOLLAB_VERSION_STRING}
)

target_link_libraries(inftube
                      ktecollaborativecommon
                      ${KDE4_KDEUI_LIBS}
                      ${TELEPATHY_QT4_LIBRARIES}
                      ${KTP_LIBRARIES}
                      ${KDE4_KIO_LIBS}
                      ${KTP_MODELS_LIBRARIES}
                      ${KTP_WIDGETS_LIBRARIES}
)

install(TARGETS inftube ${INSTALL_TARGETS_DEFAULT_ARGS})

# the tube handlers
kde4_add_executable(infinoteclienttubehandler clienttubehandler.cpp)
target_link_libraries(infinoteclienttubehandler
                      inftube
                      ${KTP_LIBRARIES}
                      ${KDE4_KIO_LIBS}
                      ${KDE4_KDEUI_LIBS}
                      ${TELEPATHY_QT4_LIBRARIES}
)

kde4_add_executable(infinoteservertubehandler servertubehandler.cpp)
target_link_libraries(infinoteservertubehandler
                      inftube
                      ${KTP_LIBRARIES}
                      ${KDE4_KIO_LIBS}
                      ${KDE4_KDEUI_LIBS}
                      ${TELEPATHY_QT4_LIBRARIES}
)

# find infinoted and tell the program
find_program(infinoted infinoted-0.5 NAMES infinoted infinoted-0.5 HINTS /usr/bin)
if ( NOT infinoted )
    message(FATAL_ERROR "Could not find infinoted (infinoted-0.5 executable), which is required to start collaborative sessions.")
endif()
configure_file(infinoted.h.in infinoted.h)

install(TARGETS infinoteclienttubehandler DESTINATION ${LIBEXEC_INSTALL_DIR})
install(TARGETS infinoteservertubehandler DESTINATION ${LIBEXEC_INSTALL_DIR})
configure_file(org.freedesktop.Telepathy.Client.KTp.infinote.service.in
               ${CMAKE_CURRENT_BINARY_DIR}/org.freedesktop.Telepathy.Client.KTp.infinote.service)
configure_file(org.freedesktop.Telepathy.Client.KTp.infinoteServer.service.in
               ${CMAKE_CURRENT_BINARY_DIR}/org.freedesktop.Telepathy.Client.KTp.infinoteServer.service)
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/org.freedesktop.Telepathy.Client.KTp.infinote.service
              ${CMAKE_CURRENT_BINARY_DIR}/org.freedesktop.Telepathy.Client.KTp.infinoteServer.service
        DESTINATION ${DBUS_SERVICES_INSTALL_DIR})
install(FILES KTp.infinote.client KTp.infinoteServer.client DESTINATION ${SHARE_INSTALL_PREFIX}/telepathy/clients/)
install(FILES ktp_kte-collaborative.desktop DESTINATION ${SHARE_INSTALL_PREFIX}/kde4/services)

=== po/pt/CMakeLists.txt ===
file(GLOB _po_files *.po)
GETTEXT_PROCESS_PO_FILES(pt ALL INSTALL_DESTINATION ${LOCALE_INSTALL_DIR} ${_po_files} )

=== po/ug/CMakeLists.txt ===
file(GLOB _po_files *.po)
GETTEXT_PROCESS_PO_FILES(ug ALL INSTALL_DESTINATION ${LOCALE_INSTALL_DIR} ${_po_files} )

=== debian/changelog ===
kte-collaborative (0.2.0-0ubuntu1) trusty; urgency=medium

  [ Jonathan Riddell ]
  * Kubuntu upload from Debian mentors, LP: #1216743

  [ Scarlett Clark ]
  * Fix copyright 

 -- Jonathan Riddell <jriddell@ubuntu.com>  Thu, 13 Feb 2014 11:46:50 +0000

kte-collaborative (0.2.0-1) experimental; urgency=low

  * Initial release (Closes: #725110)

 -- Diane Trout <diane@ghic.org>  Sat, 02 Nov 2013 09:01:13 -0700

=== debian/control ===
Source: kte-collaborative
Section: kde
Priority: optional
Maintainer: Kubuntu Developers <kubuntu-devel@lists.ubuntu.com>
XSBC-Original-Maintainer: Debian KDE Extras Team <pkg-kde-extras@lists.alioth.debian.org>
Uploaders: Diane Trout <diane@ghic.org>
Build-Depends: debhelper (>= 9), cmake, pkg-kde-tools,
 kdelibs5-dev (>= 4:4.5.0),
 libtelepathy-qt4-dev( >= 0.8.9),
 libktpcommoninternalsprivate-dev (>= 0.7.0),
 libqinfinity-dev (>= 1:0.5.2),
 libinfinity-0.5-dev,
 infinoted-0.5,
 libgsasl7-dev
Standards-Version: 3.9.4
Homepage: https://projects.kde.org/projects/playground/network/kte-collaborative
Vcs-Git: git://anonscm.debian.org/pkg-kde/kde-extras/kde-telepathy/kte-collaborative.git
Vcs-Browser: http://anonscm.debian.org/gitweb/?p=pkg-kde/kde-extras/kde-telepathy/kte-collaborative.git

Package: kte-collaborative
Architecture: any
Depends: ${shlibs:Depends}, ${misc:Depends}
Description: Collaborative Text Editor support for KDE
 kte-collaborative provides a KIO and Kate plugin to access infinote
 files. You can open files directly as
 inf://myusername@servername.tld:port/path/to/document.txt or
 you can browse infinote servers using the KDE file dialog or file managers.
 .
 You can also use Telepathy to establish pseudo peer-to-peer connections
 to jabber contacts from the same menu.

Package: kte-collaborative-dbg
Section: debug
Architecture: any
Priority: extra
Depends: kte-collaborative (= ${binary:Version}), ${shlibs:Depends}, ${misc:Depends}
Description: Debug symbols for KDE Text Editor collaborative plugin
 kte-collaborative provides a KIO and Kate plugin to access infinote
 files. You can open files directly as
 inf://myusername@servername.tld:port/path/to/document.txt or
 you can browse infinote servers using the KDE file dialog or file managers.
 .
 This package contains debugging symbols.

=== debian/rules ===
#!/usr/bin/make -f
# Uncomment this to turn on verbose mode.
export DH_VERBOSE=1

include /usr/share/dpkg/architecture.mk

%:
	dh $@ --with kde --list-missing --dbg-package=kte-collaborative-dbg

override_dh_auto_install:
	dh_auto_install --destdir=debian/kte-collaborative
	rm debian/kte-collaborative/usr/lib/libinftube.so
	rm debian/kte-collaborative/usr/lib/libktecollaborativecommon.so

.PHONY: override_dh_auto_test

=== debian/watch ===
version=3
http://download.kde.org/stable/kte-collaborative/([0-9.]+)/src/kte-collaborative-v?([0-9.]+).tar.xz
